"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateBuildResult = exports.generateDevBuildResult = exports.generateProdBuildResult = exports.generateProdUrl = void 0;
var ramda_1 = __importDefault(require("ramda"));
function generateProdUrl(_a) {
    var extType = _a.extType, extUuid = _a.extUuid, registerComponent = _a.registerComponent, SDKVersion = _a.SDKVersion, md5 = _a.md5, rnbaseurl = _a.rnbaseurl, rnbasemd5 = _a.rnbasemd5, RNVersion = _a.RNVersion;
    var values = {
        rnext: 1,
        hyaction: 'newrn',
        // 1. 不要轻易改变这个 rnmodule 格式, 可能会影响到后端的统计
        // 2. 这个名称不要包含非 ascii 值
        rnmodule: "".concat(extUuid, "-").concat(extType, "-").concat(extUuid),
        rnentry: registerComponent,
        sdkversion: SDKVersion,
        rnmd5: md5,
        framework: RNVersion || process.env.HYEXT_RN_VER || '0',
    };
    if (rnbaseurl && rnbasemd5) {
        values = __assign(__assign({}, values), { rnbaseurl: rnbaseurl, rnbasemd5: rnbasemd5 });
    }
    return Object.entries(values).map(function (_a) {
        var k = _a[0], v = _a[1];
        return "".concat(k, "=").concat(encodeURIComponent(v));
    }).join('&');
}
exports.generateProdUrl = generateProdUrl;
var generateDevUrl = function (component, platform) {
    return "rnentry=".concat(component, "&platform=").concat(platform, "&rnext=1&hyaction=newrn");
};
function generateProdBuildResult(_a) {
    var builderName = _a.builderName, extInfo = _a.extInfo, buildResultConfig = _a.buildResultConfig;
    var config = buildResultConfig.map(function (cfg) { return (__assign(__assign({}, cfg), { registerComponents: cfg.registerComponents.map(function (_a) {
            var name = _a.name, queryString = _a.queryString;
            return ({
                name: name,
                queryString: queryString || generateProdUrl(__assign(__assign({}, extInfo), { extType: cfg.extType, registerComponent: name, SDKVersion: cfg.SDKVersion, md5: cfg.bundleMd5, rnbaseurl: cfg.baseUrl, rnbasemd5: cfg.baseMd5 })),
            });
        }) })); });
    return generateBuildResult({
        builderName: builderName,
        devServerOrigin: '',
        buildResultConfig: config,
    });
}
exports.generateProdBuildResult = generateProdBuildResult;
function generateDevBuildResult(_a) {
    var builderName = _a.builderName, devServerOrigin = _a.devServerOrigin, buildResultConfig = _a.buildResultConfig;
    var config = buildResultConfig.map(function (cfg) { return (__assign(__assign({}, cfg), { registerComponents: cfg.registerComponents.map(function (_a) {
            var name = _a.name, queryString = _a.queryString;
            return ({
                name: name,
                queryString: queryString || generateDevUrl(name, cfg.platform)
            });
        }) })); });
    return generateBuildResult({
        builderName: builderName,
        devServerOrigin: devServerOrigin,
        buildResultConfig: config,
    });
}
exports.generateDevBuildResult = generateDevBuildResult;
function generateBuildResult(_a) {
    var builderName = _a.builderName, devServerOrigin = _a.devServerOrigin, buildResultConfig = _a.buildResultConfig;
    var buildResult = {};
    buildResultConfig.forEach(function (_a) {
        var _b, _c;
        var extType = _a.extType, bundleRelativePath = _a.bundleRelativePath, registerComponents = _a.registerComponents, platform = _a.platform, SDKVersion = _a.SDKVersion, _d = _a.bundleType, bundleType = _d === void 0 ? 'RN_BUNDLE' : _d;
        var result = (_b = {},
            _b[extType] = {
                type: bundleType,
                builder: builderName,
                content: {
                    sdkVersion: SDKVersion,
                    baseURI: devServerOrigin,
                    rnBundle: (_c = {},
                        _c[platform] = {
                            path: bundleRelativePath,
                            entries: registerComponents.map(function (_a) {
                                var name = _a.name, queryString = _a.queryString;
                                return ({
                                    name: name,
                                    url: queryString,
                                });
                            })
                        },
                        _c),
                },
            },
            _b);
        buildResult = ramda_1.default.mergeDeepLeft(result, buildResult);
    });
    return buildResult;
}
exports.generateBuildResult = generateBuildResult;
