"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dbg = void 0;
var chalk_1 = __importDefault(require("chalk"));
var debug_1 = __importDefault(require("debug"));
var constants_1 = require("../constants");
exports.dbg = (0, debug_1.default)(constants_1.APP_NAME);
var SEPARATOR = ', ';
var verbose = false;
var disabled = false;
var formatMessages = function (messages) {
    return chalk_1.default.reset(messages.join(SEPARATOR));
};
var success = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (!disabled) {
        console.log("".concat(chalk_1.default.green.bold('success'), " ").concat(formatMessages(messages)));
    }
};
var info = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (!disabled) {
        console.log("".concat(chalk_1.default.cyan.bold('info'), " ").concat(formatMessages(messages)));
    }
};
var warn = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (!disabled) {
        console.warn("".concat(chalk_1.default.yellow.bold('warn'), " ").concat(formatMessages(messages)));
    }
};
var error = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (!disabled) {
        console.error("".concat(chalk_1.default.red.bold('error'), " ").concat(formatMessages(messages)));
    }
};
var debug = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (verbose && !disabled) {
        console.log("".concat(chalk_1.default.gray.bold('debug'), " ").concat(formatMessages(messages)));
    }
};
var log = function () {
    var messages = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        messages[_i] = arguments[_i];
    }
    if (!disabled) {
        console.log("".concat(formatMessages(messages)));
    }
};
var setVerbose = function (level) {
    verbose = level;
};
var isVerbose = function () { return verbose; };
var disable = function () {
    disabled = true;
};
var enable = function () {
    disabled = false;
};
exports.default = {
    success: success,
    info: info,
    warn: warn,
    error: error,
    debug: debug,
    log: log,
    setVerbose: setVerbose,
    isVerbose: isVerbose,
    disable: disable,
    enable: enable,
};
