"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.batchCompile = void 0;
// @ts-ignore
var DependencyGraph_1 = __importDefault(require("metro/src/node-haste/DependencyGraph"));
// @ts-ignore
var Transformer_1 = __importDefault(require("metro/src/DeltaBundler/Transformer"));
// @ts-ignore
var DeltaCalculator_1 = __importDefault(require("metro/src/DeltaBundler/DeltaCalculator"));
var path_1 = __importDefault(require("path"));
// @ts-ignore
var saveAssets_1 = __importDefault(require("@react-native-community/cli-plugin-metro/build/commands/bundle/saveAssets"));
var saveOutput_1 = __importDefault(require("./saveOutput"));
var calcTransformerOptions_1 = require("./calcTransformerOptions");
var getType_1 = require("./getType");
var getAssets_1 = require("./getAssets");
var getPrepended_1 = require("./getPrepended");
var getExtMetroConfig_1 = require("../matrix-config/getExtMetroConfig");
function batchCompile(_a) {
    var _b;
    var config = _a.config, bundleConfigs = _a.bundleConfigs;
    return __awaiter(this, void 0, void 0, function () {
        var serializerOptions, dependencyGraph, transformer, absoluteEntryFiles, getPlatformGraph, graphList, _c, _d, _e, _f, promiseFactories, outputList, assets;
        var _this = this;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    serializerOptions = {
                        excludeSource: false,
                        inlineSourceMap: false,
                        modulesOnly: false,
                        runModule: true,
                        sourceMapUrl: undefined,
                        sourceUrl: undefined,
                    };
                    return [4 /*yield*/, DependencyGraph_1.default.load(config, { watch: false })];
                case 1:
                    dependencyGraph = _g.sent();
                    transformer = new Transformer_1.default(config, dependencyGraph.getSha1.bind(dependencyGraph));
                    absoluteEntryFiles = bundleConfigs.map(function (xs) { return xs.entryAbsPath; });
                    getPlatformGraph = function (platform) { return __awaiter(_this, void 0, void 0, function () {
                        var transformOptions, calculatedOptions, deltaCalculator, graph, _getAssets, _a, prepend, assets;
                        var _b, _c;
                        return __generator(this, function (_d) {
                            switch (_d.label) {
                                case 0:
                                    transformOptions = {
                                        customTransformOptions: Object.create(null),
                                        dev: false,
                                        hot: false,
                                        minify: true,
                                        platform: platform,
                                        runtimeBytecodeVersion: undefined,
                                        type: 'module',
                                        unstable_transformProfile: 'default',
                                    };
                                    return [4 /*yield*/, (0, calcTransformerOptions_1.calcTransformerOptions)(config, transformOptions)];
                                case 1:
                                    calculatedOptions = _d.sent();
                                    deltaCalculator = new DeltaCalculator_1.default(absoluteEntryFiles, dependencyGraph, {
                                        resolve: function (from, to) { return dependencyGraph.resolveDependency(from, to, platform); },
                                        transform: function (filepath) {
                                            if (!config.serializer.processModuleFilter({ path: filepath })) {
                                                return Promise.resolve(getExtMetroConfig_1.skipModulePlaceHolder);
                                            }
                                            return transformer.transformFile(filepath, __assign(__assign({}, calculatedOptions), { type: (0, getType_1.getType)(config, calculatedOptions, filepath), inlineRequires: false }));
                                        },
                                        transformOptions: transformOptions,
                                        onProgress: null,
                                        experimentalImportBundleSupport: false,
                                        shallow: false,
                                    });
                                    return [4 /*yield*/, deltaCalculator.getDelta({ reset: true, shallow: false })];
                                case 2:
                                    _d.sent();
                                    graph = deltaCalculator.getGraph();
                                    (_c = (_b = config.serializer) === null || _b === void 0 ? void 0 : _b.experimentalSerializerHook) === null || _c === void 0 ? void 0 : _c.call(_b, graph, {
                                        added: graph.dependencies,
                                        modified: new Map(),
                                        deleted: new Set(),
                                        reset: true,
                                    });
                                    _getAssets = function () {
                                        if (platform === 'ios') {
                                            return (0, getAssets_1.getAssets)({
                                                entryFiles: absoluteEntryFiles,
                                                config: config,
                                                transformOptions: transformOptions,
                                                dependencyGraph: dependencyGraph,
                                                transformer: transformer,
                                            });
                                        }
                                        return [];
                                    };
                                    return [4 /*yield*/, Promise.all([
                                            (0, getPrepended_1.getPrepended)({
                                                config: config,
                                                transformOptions: transformOptions,
                                                dependencyGraph: dependencyGraph,
                                                platform: platform,
                                                transformer: transformer,
                                                extraVars: {
                                                    __HYEXT_RN_VER__: "".concat(process.env.HYEXT_RN_VER || '0.67.2'),
                                                    HYEXT_BUILD_ENV: "".concat(process.env.HYEXT_BUILD_ENV || 'dev'),
                                                    HYEXT_BUILD_TYPE: 'rn',
                                                    HYEXT_IMAGE_BASE_URL: config.imageBaseURL.endsWith('/')
                                                        ? config.imageBaseURL.slice(0, config.imageBaseURL.length - 1)
                                                        : config.imageBaseURL,
                                                },
                                            }),
                                            _getAssets(),
                                        ])];
                                case 3:
                                    _a = _d.sent(), prepend = _a[0], assets = _a[1];
                                    return [2 /*return*/, { graph: graph, prepend: prepend, deltaCalculator: deltaCalculator, platform: platform, assets: assets }];
                            }
                        });
                    }); };
                    graphList = [];
                    _d = (_c = graphList).push;
                    return [4 /*yield*/, getPlatformGraph('ios')];
                case 2:
                    _d.apply(_c, [_g.sent()]);
                    _f = (_e = graphList).push;
                    return [4 /*yield*/, getPlatformGraph('android')];
                case 3:
                    _f.apply(_e, [_g.sent()]);
                    promiseFactories = [];
                    bundleConfigs.forEach(function (xs) {
                        graphList.forEach(function (grph) {
                            promiseFactories.push(function () { return (0, saveOutput_1.default)({
                                entryAbsPath: xs.entryAbsPath,
                                outputAbsPath: path_1.default.join(xs.outputDir, "index.".concat(grph.platform, ".jsbundle")),
                                dependencyGraph: dependencyGraph,
                                graph: grph.graph,
                                config: config,
                                serializerOptions: serializerOptions,
                                prepend: grph.prepend,
                                platform: grph.platform,
                            }); });
                        });
                    });
                    return [4 /*yield*/, promiseFactories.reduce(function (queue, cur) {
                            // @ts-ignore
                            return queue.then(function (acc) { return cur().then(function (result) { return (__spreadArray(__spreadArray([], acc, true), [result], false)); }); });
                        }, Promise.resolve([]))];
                case 4:
                    outputList = _g.sent();
                    assets = (_b = graphList.find(function (xs) { return xs.platform === 'ios'; })) === null || _b === void 0 ? void 0 : _b.assets;
                    return [4 /*yield*/, (0, saveAssets_1.default)(assets, 'ios', config.assetsDir)];
                case 5:
                    _g.sent();
                    graphList.forEach(function (_a) {
                        var deltaCalculator = _a.deltaCalculator;
                        return deltaCalculator.end();
                    });
                    transformer.end();
                    dependencyGraph.end();
                    return [2 /*return*/, outputList];
            }
        });
    });
}
exports.batchCompile = batchCompile;
