"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bundleToString = void 0;
function bundleToString(bundle) {
    var code = bundle.pre.length > 0 ? bundle.pre + '\n' : '';
    var modules = [];
    var sortedModules = bundle.modules
        .slice()
        .sort(function (a, b) {
        if (a > b)
            return 1;
        if (a < b)
            return -1;
        return 0;
    });
    for (var _i = 0, sortedModules_1 = sortedModules; _i < sortedModules_1.length; _i++) {
        var _a = sortedModules_1[_i], id = _a[0], moduleCode = _a[1];
        if (moduleCode.length > 0) {
            code += moduleCode + '\n';
        }
        modules.push([id, moduleCode.length]);
    }
    if (bundle.post.length > 0) {
        code += bundle.post;
    }
    else {
        code = code.slice(0, -1);
    }
    return {
        code: code,
        metadata: { pre: bundle.pre.length, post: bundle.post.length, modules: modules },
    };
}
exports.bundleToString = bundleToString;
