"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDependencies = void 0;
// @ts-ignore
var DeltaCalculator_1 = __importDefault(require("metro/src/DeltaBundler/DeltaCalculator"));
var calcTransformerOptions_1 = require("./calcTransformerOptions");
var getType_1 = require("./getType");
var getExtMetroConfig_1 = require("../matrix-config/getExtMetroConfig");
function getDependencies(options) {
    return __awaiter(this, void 0, void 0, function () {
        var dependencyGraph, config, entryFiles, transformOptions, transformer, _a, otherOptions, calculatedOptions, deltaCalculator, graph;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    dependencyGraph = options.dependencyGraph, config = options.config, entryFiles = options.entryFiles, transformOptions = options.transformOptions, transformer = options.transformer, _a = options.otherOptions, otherOptions = _a === void 0 ? {
                        onProgress: null,
                        shallow: false,
                    } : _a;
                    return [4 /*yield*/, (0, calcTransformerOptions_1.calcTransformerOptions)(config, transformOptions)];
                case 1:
                    calculatedOptions = _b.sent();
                    deltaCalculator = new DeltaCalculator_1.default(entryFiles, dependencyGraph, {
                        resolve: function (from, to) { return dependencyGraph.resolveDependency(from, to, transformOptions.platform); },
                        transform: function (filepath) {
                            if (!config.serializer.processModuleFilter({ path: filepath })) {
                                return Promise.resolve(getExtMetroConfig_1.skipModulePlaceHolder);
                            }
                            return transformer.transformFile(filepath, __assign(__assign({}, calculatedOptions), { type: (0, getType_1.getType)(config, calculatedOptions, filepath), inlineRequires: false }));
                        },
                        transformOptions: transformOptions,
                        onProgress: otherOptions.onProgress,
                        experimentalImportBundleSupport: config.transformer.experimentalImportBundleSupport,
                        shallow: otherOptions.shallow,
                    });
                    return [4 /*yield*/, deltaCalculator.getDelta({ reset: true, shallow: otherOptions.shallow })];
                case 2:
                    _b.sent();
                    graph = deltaCalculator.getGraph();
                    deltaCalculator.end();
                    return [2 /*return*/, graph.dependencies];
            }
        });
    });
}
exports.getDependencies = getDependencies;
