"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPrepended = void 0;
// @ts-ignore
var defaults_1 = __importDefault(require("metro-config/src/defaults/defaults"));
// @ts-ignore
var getPreludeCode_1 = __importDefault(require("metro/src/lib/getPreludeCode"));
// @ts-ignore
var countLines_1 = __importDefault(require("metro/src/lib/countLines"));
var getDependencies_1 = require("./getDependencies");
var getPrepended = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var config, transformOptions, dependencyGraph, platform, transformer, extraVars, polyfillModuleNames, dependencies, getPrelude;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                config = options.config, transformOptions = options.transformOptions, dependencyGraph = options.dependencyGraph, platform = options.platform, transformer = options.transformer, extraVars = options.extraVars;
                polyfillModuleNames = config.serializer
                    .getPolyfills({ platform: platform })
                    .concat(config.serializer.polyfillModuleNames);
                return [4 /*yield*/, (0, getDependencies_1.getDependencies)({
                        entryFiles: __spreadArray([defaults_1.default.moduleSystem], polyfillModuleNames, true),
                        config: config,
                        dependencyGraph: dependencyGraph,
                        transformer: transformer,
                        transformOptions: __assign(__assign({}, transformOptions), { type: 'script' })
                    })];
            case 1:
                dependencies = _a.sent();
                getPrelude = function () {
                    var code = (0, getPreludeCode_1.default)({
                        isDev: transformOptions.dev,
                        globalPrefix: config.transformer.globalPrefix,
                        extraVars: extraVars,
                    });
                    var name = '__prelude__';
                    return {
                        dependencies: new Map(),
                        getSource: function () { return Buffer.from(code); },
                        inverseDependencies: new Set(),
                        path: name,
                        output: [
                            {
                                type: 'js/script/virtual',
                                data: {
                                    code: code,
                                    lineCount: (0, countLines_1.default)(code),
                                    map: [],
                                },
                            },
                            {
                                type: 'bytecode/script/virtual',
                                data: {
                                    // TODO: hermesCompiler 有副作用, 引入后会影响当前进程.
                                    // 1. 进程抛出的错误会被它捕获, 然后仅抛出有限的错误信息
                                    // 2. 会产生一些奇怪的行为, 比如 babel-loader 中的 AcornParser.extend 会抛出错误:
                                    // RuntimeError: abort(TypeError: AcornParser.extend is not a function). Build with -s ASSERTIONS=1 for more info
                                    // bytecode: hermesCompiler(code, { sourceURL: '__prelude__.virtual.js' }).bytecode,
                                    bytecode: Buffer.from('')
                                },
                            },
                        ],
                    };
                };
                return [2 /*return*/, __spreadArray([
                        getPrelude()
                    ], dependencies.values(), true)];
        }
    });
}); };
exports.getPrepended = getPrepended;
