"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSortedModules = void 0;
var getSortedModules = function (graph, createModuleId) {
    var modules = __spreadArray([], graph.dependencies.values(), true);
    // 源码这里为什么要特意执行一次?
    // Assign IDs to modules in a consistent order
    // for (const module of modules) {
    //   this._createModuleId(module.path);
    // }
    // 其实 createModuleId 的签名是 string => number 的, 但小程序因历史原因,
    // 用的是 string => string, 所以内部的所有的排序都要注意
    return modules.sort(function (a, z) {
        var idA = createModuleId(a.path);
        var idZ = createModuleId(z.path);
        if (idA === idZ)
            return 0;
        if (idA > idZ)
            return 1;
        return -1;
    });
};
exports.getSortedModules = getSortedModules;
