"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
var baseJSBundle_1 = __importDefault(require("metro/src/DeltaBundler/Serializers/baseJSBundle"));
// @ts-ignore
var sourceMapString_1 = __importDefault(require("metro/src/DeltaBundler/Serializers/sourceMapString"));
var path_1 = __importDefault(require("path"));
var bunldeToString_1 = require("./bunldeToString");
var getSortedModules_1 = require("./getSortedModules");
var fs_extra_1 = __importDefault(require("fs-extra"));
var md5_1 = __importDefault(require("../lib/md5"));
var saveOutput = function (outputOptions) { return __awaiter(void 0, void 0, void 0, function () {
    var entryAbsPath, outputAbsPath, dependencyGraph, graph, config, serializerOptions, prepend, platform, bundleOptions, bundleCode, bundleMap;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                entryAbsPath = outputOptions.entryAbsPath, outputAbsPath = outputOptions.outputAbsPath, dependencyGraph = outputOptions.dependencyGraph, graph = outputOptions.graph, config = outputOptions.config, serializerOptions = outputOptions.serializerOptions, prepend = outputOptions.prepend, platform = outputOptions.platform;
                bundleOptions = {
                    asyncRequireModulePath: dependencyGraph.resolveDependency("".concat(config.projectRoot, "/."), config.transformer.asyncRequireModulePath),
                    processModuleFilter: config.serializer.processModuleFilter,
                    createModuleId: config.serializer.createModuleIdFactory(),
                    getRunModuleStatement: config.serializer.getRunModuleStatement,
                    dev: false,
                    projectRoot: config.projectRoot,
                    modulesOnly: serializerOptions.modulesOnly,
                    runBeforeMainModule: config.serializer.getModulesRunBeforeMainModule(path_1.default.relative(config.projectRoot, entryAbsPath)),
                    runModule: serializerOptions.runModule,
                    sourceMapUrl: serializerOptions.sourceMapUrl || "".concat(path_1.default.basename(outputAbsPath), ".map"),
                    sourceUrl: serializerOptions.sourceUrl,
                    inlineSourceMap: serializerOptions.inlineSourceMap,
                    serverRoot: config.projectRoot,
                };
                bundleCode = (0, bunldeToString_1.bundleToString)((0, baseJSBundle_1.default)(entryAbsPath, prepend, graph, bundleOptions)).code;
                bundleMap = (0, sourceMapString_1.default)(__spreadArray(__spreadArray([], prepend, true), (0, getSortedModules_1.getSortedModules)(graph, config.serializer.createModuleIdFactory()), true), {
                    excludeSource: serializerOptions.excludeSource,
                    processModuleFilter: config.serializer.processModuleFilter,
                });
                return [4 /*yield*/, fs_extra_1.default.ensureDir(path_1.default.dirname(outputAbsPath))];
            case 1:
                _b.sent();
                return [4 /*yield*/, Promise.all([
                        fs_extra_1.default.writeFile(outputAbsPath, bundleCode, { encoding: 'utf8' }),
                        fs_extra_1.default.writeFile("".concat(outputAbsPath, ".map"), bundleMap),
                    ])];
            case 2:
                _b.sent();
                _a = {
                    entryAbsPath: entryAbsPath,
                    bundleAbsPath: outputAbsPath
                };
                return [4 /*yield*/, (0, md5_1.default)(outputAbsPath)];
            case 3: return [2 /*return*/, (_a.bundleMd5 = _b.sent(),
                    _a.platform = platform,
                    _a)];
        }
    });
}); };
exports.default = saveOutput;
