"use strict";
function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _objectSpreadProps(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
var cssLoader = require("@hyext/compile");
var upstreamTransformer = require("metro-react-native-babel-transformer");
var extname = require("path").extname;
var BabelJsx2StyleheetPlugin = require("babel-plugin-transform-jsx-to-hy-stylesheet");
var BabelJsxSyntaxPlugin = require("@babel/plugin-syntax-jsx");
var BabelProposalClassPlugin = require("@babel/plugin-proposal-class-properties");
var BabelTypescriptPlugin = require("@babel/plugin-transform-typescript");
// type transformerArgs = {
//   filename: string;
//   options: {
//     hyextTransformerConfig?: {
//      scalePx2dp_design_width?: number,
//      scalePx2dp_disable?: boolean,
//      scalePx2dp_by_orientation_width?: boolean,
//     }
//   };
//   plugins: [string, object][];
//   src: string;
// };
var babelPluginsStr = process.env.MATRIX_BABEL_PLUGINS || "[]";
var hyextTransformerConfigStr = process.env.MATRIX_HYEXT_TRANSFORMER_CONFIG || "{}";
module.exports = {
    transform: function transform(args, registryPath, assetPlugins) {
        var src = args.src, filename = args.filename, options = args.options, _plugins = args.plugins, plugins = _plugins === void 0 ? [] : _plugins;
        var finalOptions = _objectSpreadProps(_objectSpread({}, options), {
            hyextTransformerConfig: JSON.parse(hyextTransformerConfigStr)
        });
        var finalPlugins = _toConsumableArray(plugins).concat(_toConsumableArray(JSON.parse(babelPluginsStr)));
        // 不管是业务文件还是 npm 文件 , 都进行 css/hycss 的预处理
        if (filename.endsWith(".css") || filename.endsWith(".hycss")) {
            src = cssLoader.feature.transformCss2Js(src, filename, finalOptions, finalPlugins);
        }
        // 处理业务的js文件, 进行stylesheet 的预处理
        var codeExts = [
            ".js",
            ".jsx",
            ".tsx",
            ".ts"
        ];
        if (!filename.includes("node_modules") && codeExts.includes(extname(filename))) {
            // 如果分两次 transform 的话, sourcemap 信息会丢失
            // src = cssLoader.feature.transformStylesheet(src, filename, finalOptions, finalPlugins);
            finalPlugins = _toConsumableArray(finalPlugins).concat([
                [
                    BabelJsx2StyleheetPlugin,
                    {
                        replacePath: false
                    }
                ],
                [
                    BabelJsxSyntaxPlugin
                ],
                [
                    BabelProposalClassPlugin
                ],
                [
                    BabelTypescriptPlugin,
                    {
                        isTSX: true
                    }
                ], 
            ]);
        }
        return upstreamTransformer.transform({
            src: src,
            filename: filename,
            options: finalOptions,
            plugins: finalPlugins
        });
    }
};
