"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExtMetroConfig = exports.skipModulePlaceHolder = void 0;
var path_1 = __importDefault(require("path"));
// @ts-ignore untyped metro-cache
var metro_cache_1 = require("metro-cache");
// @ts-ignore
var metro_config_1 = require("metro-config");
// @ts-ignore
var defaults_1 = require("metro-config/src/defaults");
var cli_plugin_metro_1 = require("@react-native-community/cli-plugin-metro");
var createModuleIdHOF_1 = require("./createModuleIdHOF");
var resolveReactNativePath_1 = __importDefault(require("./resolveReactNativePath"));
var filterModuleHOF_1 = __importDefault(require("./filterModuleHOF"));
var ramda_1 = require("ramda");
exports.skipModulePlaceHolder = {
    dependencies: [],
    output: [],
    getSource: function () { return Buffer.from(''); },
};
// TODO: 搜索 ext-sdk 所在文件夹
function getExtMetroConfig(options) {
    var _this = this;
    var projectRoot = options.projectRoot, mode = options.mode, projectConfig = options.projectConfig, _a = options.extMetroConfig, _b = _a.filterModules, filterModules = _b === void 0 ? new Set() : _b, _c = _a.filterModulesVersion, filterModulesVersion = _c === void 0 ? new Set() : _c, _d = _a.SDKAlias, SDKAlias = _d === void 0 ? {} : _d, _e = _a.extraPolyfills, extraPolyfills = _e === void 0 ? [] : _e, _f = _a.extraModulesRunFirst, extraModulesRunFirst = _f === void 0 ? [] : _f;
    // metro 默认值: metro-config/src/defaults/index.js
    var officialDefaultConfig = (0, defaults_1.getDefaultValues)(projectRoot);
    var officialCliConfig = (0, cli_plugin_metro_1.getDefaultConfig)({
        platforms: {},
        reactNativePath: (0, resolveReactNativePath_1.default)([process.env.MATRIX_SHARE_PROJECT_RN_ROOT, projectRoot].filter(Boolean)),
    });
    var officialConfig = (0, metro_config_1.mergeConfig)(officialDefaultConfig, officialCliConfig);
    // 所以的依赖必须要归到 watchFolder 中去, 否则找不到相关的文件, 或者文件缺失md5
    var extraWatchFolder = [
        'metro-runtime/src/modules/asyncRequire',
        '@react-native-community/cli-plugin-metro', // or come from here
    ]
        .map(function (xs) { return require.resolve(xs); })
        .map(function (xs) { return require.resolve('metro-runtime/src/modules/asyncRequire', { paths: [xs] }); }) // watch asyncRequire 所在的文件夹
        .map(function (xs) { return path_1.default.dirname(xs); });
    // watch matrix-config 所在的文件夹
    extraWatchFolder.push(path_1.default.resolve(__dirname));
    // watch metro-runtime/src 文件夹
    extraWatchFolder.push(path_1.default.join(path_1.default.dirname(require.resolve('metro-runtime/package.json')), 'src'));
    extraWatchFolder.push.apply(extraWatchFolder, __spreadArray(__spreadArray([], extraModulesRunFirst.map(function (xs) { return path_1.default.dirname(xs); }), false), extraPolyfills.map(function (xs) { return path_1.default.dirname(xs); }), false));
    /*
     * 开发环境下, 这个值设置为true, 否则会遇到问题:
     * https://github.com/facebook/react-native/issues/28801
     */
    var inlineRequires = true;
    var watchFolders = (0, ramda_1.uniq)(__spreadArray([projectRoot], extraWatchFolder, true));
    var nodeModulesPaths = [path_1.default.join(projectRoot, 'node_modules')];
    var assetRegistryPath = officialConfig.transformer.assetRegistryPath;
    var useWatchman = true;
    var createModuleIdFactory = createModuleIdHOF_1.defaultFactory;
    if (mode !== 'dev') {
        inlineRequires = false;
        assetRegistryPath = path_1.default.resolve(path_1.default.join(__dirname, 'assetRegistry.js'));
        useWatchman = false;
        createModuleIdFactory = (0, createModuleIdHOF_1.createModuleIdHOF)({ projectRoot: projectRoot, SDKAlias: SDKAlias, filterModules: filterModules });
        if (process.env.MATRIX_SHARE_PROJECT_RN_ROOT) {
            var shareModules = path_1.default.join(process.env.MATRIX_SHARE_PROJECT_RN_ROOT, 'node_modules');
            // 大部分包(react/react-dom/react-native/sdk)其实都在 projectRoot/node_modules 这一层,
            // 所以先搜索这个位置比较高效
            nodeModulesPaths = __spreadArray([shareModules], nodeModulesPaths, true);
            watchFolders.push(shareModules);
        }
    }
    var CACHE_PATH = path_1.default.join(process.env.MATRIX_CACHE_ROOT || path_1.default.join(projectRoot, 'node_modules', '.huya-ext-cache'), 'metro');
    var hyextConfig = {
        resolver: {
            sourceExts: __spreadArray(__spreadArray([], officialConfig.resolver.sourceExts, true), ['jsx', 'hycss'], false),
            platforms: ['ios', 'android', 'native', 'web'],
            nodeModulesPaths: nodeModulesPaths,
            blockList: __spreadArray(__spreadArray([], (Array.isArray(officialConfig.resolver.blockList) ? officialConfig.resolver.blockList : [officialConfig.resolver.blockList]), true), options.extMetroConfig.blockRegexp || [], true),
            useWatchman: useWatchman,
        },
        serializer: {
            processModuleFilter: (0, filterModuleHOF_1.default)({ projectRoot: projectRoot, SDKAlias: SDKAlias, filterModules: filterModules, filterModulesVersion: filterModulesVersion, mode: mode }),
            createModuleIdFactory: createModuleIdFactory,
            getModulesRunBeforeMainModule: function (entryRelative) {
                var officialRunBefore = officialConfig.serializer.getModulesRunBeforeMainModule(entryRelative);
                return __spreadArray(__spreadArray([], officialRunBefore, true), extraModulesRunFirst, true);
            },
            getPolyfills: function (opts) {
                var officialPolyfills = officialConfig.serializer.getPolyfills(opts);
                return __spreadArray(__spreadArray([], officialPolyfills, true), extraPolyfills, true);
            }
        },
        server: {
            port: options.port || 8081,
            // 中间件的执行顺序: communityCLI => metroMiddleware.
            // 这个中间件中的逻辑, 会晚于 communityCLI 的中间件执行
            enhanceMiddleware: undefined,
        },
        transformer: {
            // babelPlugins: [],
            enableBabelRCLookup: false,
            getTransformOptions: function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, ({
                            transform: {
                                experimentalImportSupport: false,
                                inlineRequires: inlineRequires,
                                unstable_disableES6Transforms: false,
                            },
                            preloadedModules: false,
                            ramGroups: [],
                        })];
                });
            }); },
            // asyncRequireModulePath: require.resolve('metro-runtime/src/modules/asyncRequire'),
            babelTransformerPath: path_1.default.join(__dirname, '../matrix-config/babelTransformer.js'),
            assetRegistryPath: assetRegistryPath,
            // publicPath用来决定图片的地址, 开发环境需设置为空
            publicPath: '/',
        },
        cacheStores: [
            new metro_cache_1.FileStore({ root: CACHE_PATH })
        ],
        hasteMapCacheDirectory: CACHE_PATH,
        // 确保不同的小程序能产生不同的缓存值
        cacheVersion: (projectConfig === null || projectConfig === void 0 ? void 0 : projectConfig.cacheVersion) || '1',
        projectRoot: projectRoot,
        watchFolders: watchFolders,
        onReady: function () { },
        enableRootBabelRC: false,
    };
    return (0, metro_config_1.mergeConfig)(officialDefaultConfig, officialCliConfig, hyextConfig, options.extMetroConfig);
}
exports.getExtMetroConfig = getExtMetroConfig;
