"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore untyped metro
// import Metro from '@hyext/matrix';
var metro_1 = __importDefault(require("metro"));
// @ts-ignore
var metro_core_1 = require("metro-core");
// @ts-ignore
var metro_config_1 = require("metro-config");
var path_1 = __importDefault(require("path"));
// @ts-ignore
var cli_server_api_1 = require("@react-native-community/cli-server-api");
var watchMode_1 = __importDefault(require("./watchMode"));
var constants_1 = require("../constants");
var HyTerminalReporter_1 = __importDefault(require("../lib/HyTerminalReporter"));
var hyExtMiddleware_1 = require("./hyExtMiddleware");
var getExtMetroConfig_1 = require("../matrix-config/getExtMetroConfig");
function matrixServer(config) {
    return __awaiter(this, void 0, void 0, function () {
        var reportEvent, terminal, ReporterImpl, terminalReporter, reporter, defaultConfig, finalConfig, _a, middleware, websocketEndpoints, messageSocketEndpoint, eventsSocketEndpoint, customEnhanceMiddleware, serverInstance;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    terminal = new metro_core_1.Terminal(process.stdout);
                    ReporterImpl = getReporterImpl(config.customLogReporterPath);
                    terminalReporter = new ReporterImpl(terminal);
                    reporter = {
                        update: function (event) {
                            terminalReporter.update(event);
                            if (reportEvent) {
                                reportEvent(event);
                            }
                        },
                    };
                    defaultConfig = (0, getExtMetroConfig_1.getExtMetroConfig)({
                        projectRoot: config.projectRoot,
                        mode: 'dev',
                        projectConfig: config.projectConfig,
                        extMetroConfig: config.extMetroConfig,
                    });
                    finalConfig = (0, metro_config_1.mergeConfig)(defaultConfig, {
                        reporter: reporter,
                        server: {
                            port: config.port || 8081,
                        }
                    });
                    _a = (0, cli_server_api_1.createDevServerMiddleware)({
                        host: config.host || constants_1.DEFAULT_HOST,
                        port: finalConfig.server.port,
                        watchFolders: finalConfig.watchFolders,
                    }), middleware = _a.middleware, websocketEndpoints = _a.websocketEndpoints, messageSocketEndpoint = _a.messageSocketEndpoint, eventsSocketEndpoint = _a.eventsSocketEndpoint;
                    middleware.use(cli_server_api_1.indexPageMiddleware);
                    customEnhanceMiddleware = finalConfig.server.enhanceMiddleware;
                    finalConfig.server.enhanceMiddleware = function (metroMiddleware, server) {
                        if (customEnhanceMiddleware) {
                            metroMiddleware = customEnhanceMiddleware(metroMiddleware, server);
                        }
                        // 请保持 middleware 在 metroMiddleware 之前执行
                        // 否则 metro 处理 /symbolicate 请求时会得到空的body
                        // https://github.com/facebook/metro/issues/660
                        return hyExtMiddleware_1.hyExtMiddleware.use(middleware).use(metroMiddleware);
                    };
                    return [4 /*yield*/, metro_1.default.runServer(finalConfig, {
                            host: config.host || constants_1.DEFAULT_HOST,
                            onReady: config.onReady,
                            onError: config.onError,
                            // @ts-ignore @types/metro 太旧了
                            hmrEnabled: true,
                            // @ts-ignore @types/metro 太旧了
                            websocketEndpoints: websocketEndpoints,
                        })];
                case 1:
                    serverInstance = _b.sent();
                    reportEvent = eventsSocketEndpoint.reportEvent;
                    if (config.interactive !== false) {
                        (0, watchMode_1.default)(messageSocketEndpoint);
                    }
                    serverInstance.keepAliveTimeout = 30000;
                    return [2 /*return*/, serverInstance];
            }
        });
    });
}
exports.default = matrixServer;
function getReporterImpl(customLogReporterPath) {
    if (customLogReporterPath === undefined) {
        return HyTerminalReporter_1.default;
    }
    try {
        return require(customLogReporterPath);
    }
    catch (e) {
        if (e.code !== 'MODULE_NOT_FOUND') {
            throw e;
        }
        return require(path_1.default.resolve(customLogReporterPath));
    }
}
