import matrixCompile from './matrix-compile/matrixCompile'
import matrixServer from './matrix-server/matrixServer'

import { getExtMetroConfig } from './matrix-config/getExtMetroConfig'
import { generateDevBuildResult, generateProdBuildResult } from './lib/generateBuildResult'
import { getRegisterComponents, getActualComponents } from './lib/getRegisterComponents'


export const compiler = {
  compile: matrixCompile,
  devServer: matrixServer,
  getExtMetroConfig,
}

export const utils = {
  generateDevBuildResult,
  generateProdBuildResult,

  getRegisterComponents,
  getActualComponents,
}

export * from './matrix-config/configTypes'
