import { TransformInputOptions } from "metro"
import { ConfigT } from "metro-config"

export const calcTransformerOptions = async (config: ConfigT, options: TransformInputOptions) => {
  const baseOptions = {
    customTransformOptions: options.customTransformOptions,
    dev: options.dev,
    hot: options.hot,
    inlineRequires: false,
    inlinePlatform: true,
    minify: options.minify,
    platform: options.platform,
    runtimeBytecodeVersion: options.runtimeBytecodeVersion,
    unstable_transformProfile: options.unstable_transformProfile,
  }

  if (options.type === 'script') {
    return {
      ...baseOptions,
      type: 'script',
    }
  }

  // FIXME: 可以带参数, 但是实际上没有参数, 也不需要
  // @ts-ignore
  const { transform } = await config.transformer.getTransformOptions()

  return {
    ...baseOptions,
    inlineRequires: transform?.inlineRequires || false,
    experimentalImportSupport: transform?.experimentalImportSupport || false,
    unstable_disableES6Transforms:
      transform?.unstable_disableES6Transforms || false,
    nonInlinedRequires:
      transform?.nonInlinedRequires || ['React', 'react', 'react-native'],
    type: 'module',
  }
}
