import { TransformInputOptions } from "metro"
import { ConfigT } from "metro-config"

// @ts-ignore
import DependencyGraph from 'metro/src/node-haste/DependencyGraph'
// @ts-ignore
import Transformer from 'metro/src/DeltaBundler/Transformer'
// @ts-ignore
import metroGetAssets from 'metro/src/DeltaBundler/Serializers/getAssets'

import { getDependencies } from "./getDependencies"

export const getAssets = async (options: {
  entryFiles: string[],
  config: ConfigT,
  transformOptions: TransformInputOptions,
  dependencyGraph: DependencyGraph,
  transformer: Transformer,
}) => {
  const {
    // dependencyGraph,
    config,
    transformOptions,
    // platform,
    // transformer,
  } = options

  const dependencies = await getDependencies(options)

  return metroGetAssets(dependencies, {
    processModuleFilter: config.serializer.processModuleFilter,
    assetPlugins: config.transformer.assetPlugins,
    platform: transformOptions.platform,
    projectRoot: config.projectRoot,
    publicPath: config.transformer.publicPath,
  })
}
