import { Module } from 'metro'

export const getSortedModules = (graph: any, createModuleId: (filepath: string) => string | number) => {
  const modules = [...graph.dependencies.values()]
  // 源码这里为什么要特意执行一次?
  // Assign IDs to modules in a consistent order
  // for (const module of modules) {
  //   this._createModuleId(module.path);
  // }

  // 其实 createModuleId 的签名是 string => number 的, 但小程序因历史原因,
  // 用的是 string => string, 所以内部的所有的排序都要注意
  return modules.sort((a: Module<any>, z: Module<any>) => {
    const idA = createModuleId(a.path)
    const idZ = createModuleId(z.path)

    if (idA === idZ) return 0
    if (idA > idZ) return 1

    return -1
  })
}

