import { ConfigT } from 'metro-config';
import path from 'path'
import { calcTransformerOptions } from './calcTransformerOptions';

export const getType = (config: ConfigT, calculatedOptions: Awaited<ReturnType<typeof calcTransformerOptions>>, filepath: string) => {
  if (calculatedOptions.type === 'script') {
    return 'script'
  }

  if (config.resolver.assetExts.indexOf(path.extname(filepath).slice(1)) !== -1) {
    return 'asset'
  }
  const lowerExts = config.resolver.assetExts.map(xs => xs.toLowerCase())
  const fileExt = path.extname(filepath).slice(1).toLowerCase()
  if (lowerExts.includes(fileExt)) {
    return 'asset'
  }

  return 'module'
}
