import path from 'path'

export default function resolveReactNativePath(searchDirs: string[]) {
  const resolveNodeModuleDir = (root: string, packageName: string) => {
    return path.dirname(
      //  通过部分路径找到一个包的路径
      require.resolve(path.join(packageName, 'package.json'), {
        paths: [root],
      }),
    );
  }

  for (let i = 0; i < searchDirs.length; i += 1) {
    let RNPath = ''
    try {
      RNPath = resolveNodeModuleDir(searchDirs[i], 'react-native')
      if (RNPath) return RNPath
    } catch (err) {
      // console.log(`react-native not found in ${searchDirs[i]}`)
    }
  }
  console.log(`react-native not found in ${JSON.stringify(searchDirs)}`)
}
